---
title: ConstantSourceNode
slug: Web/API/ConstantSourceNode
tags:
  - API
  - Audio
  - ConstantSourceNode
  - Interface
  - Media
  - Reference
  - Web Audio API
---
<div>{{APIRef("Web Audio API")}}</div>

<p>The <code>ConstantSourceNode</code> interface—part of the Web Audio API—represents an audio source (based upon {{domxref("AudioScheduledSourceNode")}}) whose output is single unchanging value. This makes it useful for cases in which you need a constant value coming in from an audio source. In addition, it can be used like a constructible {{domxref("AudioParam")}} by automating the value of its {{domxref("ConstantSourceNode.offset", "offset")}} or by connecting another node to it; see <a href="/en-US/docs/Web/API/Web_Audio_API/Controlling_multiple_parameters_with_ConstantSourceNode">Controlling multiple parameters with ConstantSourceNode</a>.</p>

<p>A <code>ConstantSourceNode</code> has no inputs and exactly one monaural (one-channel) output. The output's value is always the same as the value of the {{domxref("ConstantSourceNode.offset", "offset")}} parameter.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Number of inputs</th>
   <td><code>0</code></td>
  </tr>
  <tr>
   <th scope="row">Number of outputs</th>
   <td><code>1</code></td>
  </tr>
 </tbody>
</table>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("ConstantSourceNode.ConstantSourceNode", "ConstantSourceNode()")}}</dt>
 <dd>Creates and returns a new <code>ConstantSourceNode</code> instance, optionally specifying an object which establishes initial values for the object's properties. You can also create a <code>ConstantSourceNode</code> whose properties are initialized to their default values by calling {{domxref("AudioContext.createConstantSource()")}}.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p><em>Inherits properties from its parent interface, {{domxref("AudioScheduledSourceNode")}}, and adds the following properties:</em></p>

<dl>
 <dt>{{domxref("ConstantSourceNode.offset", "offset")}}</dt>
 <dd>An {{domxref("AudioParam")}} which specifies the value that this source continuously outputs. The default value is 1.0.</dd>
</dl>

<h3 id="Event_handlers">Event handlers</h3>

<p><em>Inherits event handlers from its parent interface, {{domxref("AudioScheduledSourceNode")}}.</em></p>

<div class="note">
<p>Some browsers' implementations of this event handler are part of the  {{domxref("AudioScheduledSourceNode")}} interface.</p>
</div>

<dl>
 <dt>{{domxref("AudioScheduledSourceNode.onended()","onended")}}</dt>
 <dd>Fired whenever the {{domxref('ConstantSourceNode')}} data has stopped playing.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>Inherits methods from its parent interface, {{domxref("AudioScheduledSourceNode")}}.</em></p>

<div class="note">
<p>Some browsers' implementations of these methods are part of the {{domxref("AudioScheduledSourceNode")}} interface.</p>
</div>

<dl>
 <dt>{{domxref("AudioScheduledSourceNode.start", "start()")}}</dt>
 <dd>Schedules a sound to playback at an exact time.</dd>
 <dt>{{domxref("AudioScheduledSourceNode.stop", "stop()")}}</dt>
 <dd>Schedules a sound to stop playback at an exact time.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>In the article <a href="/en-US/docs/Web/API/Web_Audio_API/Controlling_multiple_parameters_with_ConstantSourceNode">Controlling multiple parameters with ConstantSourceNode</a>, a <code>ConstantSourceNode</code> is created to allow one slider control to change the gain on two {{domxref("GainNode")}}s. The three nodes are set up like this:</p>

<pre class="brush: js">gainNode2 = context.createGain();
gainNode3 = context.createGain();
gainNode2.gain.value = gainNode3.gain.value = 0.5;
volumeSliderControl.value = gainNode2.gain.value;

constantNode = context.createConstantSource();
constantNode.connect(gainNode2.gain);
constantNode.connect(gainNode3.gain);
constantNode.start();

gainNode2.connect(context.destination);
gainNode3.connect(context.destination);
</pre>

<p>This code starts by creating the gain nodes and setting them and the volume control that will adjust their value all to 0.5. Then the <code>ConstantSourceNode</code> is created by calling {{domxref("AudioContext.createConstantSource()")}}, and the gain parameters of each of the two gain nodes are connected to the <code>ConstantSourceNode</code>. After starting the constant source by calling its {{domxref("AudioScheduledSourceNode.start", "start()")}} method. Finally, the two gain nodes are connected to the audio destination (typically speakers or headphones).</p>

<p>Now, whenever the value of {{domxref("ConstantSourceNode.offset", "constantNode.offset")}} changes, the gain on both <code>gainNode2</code> and <code>gainNode3</code> will change to have that same value.</p>

<p>To see this example in action, as well as to read the rest of the code from which these snippets were derived, see <a href="/en-US/docs/Web/API/Web_Audio_API/Controlling_multiple_parameters_with_ConstantSourceNode">Controlling multiple parameters with ConstantSourceNode.</a></p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Audio API', '#ConstantSourceNode', 'ConstantSourceNode')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.ConstantSourceNode")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
 <li>{{domxref("AudioScheduledSourceNode")}}</li>
 <li>{{domxref("AudioNode")}}</li>
</ul>
